<template>
  <div>
    Name: {{ fullName }} Message: {{ message }}
    <div>Wheels {{ wheels }} Axles {{ axles }}</div>
    <button @click="triggerAction">Hi</button>
    <button @click="request">Simple request</button>
  </div>
</template>
<script lang="ts">
import { Vue, Component, Prop } from 'nuxt-property-decorator'
import { provide, consume } from 'provide-consume-decorator'
import { getModule } from 'vuex-module-decorators'
import TestStore from '@/store/tryingStoreTest'

interface User {
  firstName: string
  lastName: string
}

interface Store {
  testing: TestStore
}

@Component({
  middleware: 'auth'
})
@provide({
  store(): Store {
    return {
      testing: getModule(TestStore, this.$store)
    }
  }
})
export default class Testing extends Vue {
  @consume('store') store!: Store

  @Prop({
    type: Object,
    required: false,
    default: (): User => ({
      firstName: 'default name',
      lastName: 'default last name'
    })
  })
  readonly user!: User

  message: string = 'This is a message'

  get axles(): number {
    return this.store.testing.axles
  }

  get wheels(): number {
    return this.store.testing.wheels
  }

  request() {
    this.store.testing.simpleRequest()
  }

  triggerAction() {
    this.store.testing.incrWheels(2)
  }

  get fullName(): string {
    return `${this.user.firstName} ${this.user.lastName}`
  }
}
</script>
